// Code generated by smithy-go-codegen DO NOT EDIT.

package ec2

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/ec2/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Describes Capacity Block extension offerings available for purchase in the
// Amazon Web Services Region that you're currently using.
func (c *Client) DescribeCapacityBlockExtensionOfferings(ctx context.Context, params *DescribeCapacityBlockExtensionOfferingsInput, optFns ...func(*Options)) (*DescribeCapacityBlockExtensionOfferingsOutput, error) {
	if params == nil {
		params = &DescribeCapacityBlockExtensionOfferingsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "DescribeCapacityBlockExtensionOfferings", params, optFns, c.addOperationDescribeCapacityBlockExtensionOfferingsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*DescribeCapacityBlockExtensionOfferingsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type DescribeCapacityBlockExtensionOfferingsInput struct {

	// The duration of the Capacity Block extension offering in hours.
	//
	// This member is required.
	CapacityBlockExtensionDurationHours *int32

	// The ID of the Capacity reservation to be extended.
	//
	// This member is required.
	CapacityReservationId *string

	// Checks whether you have the required permissions for the action, without
	// actually making the request, and provides an error response. If you have the
	// required permissions, the error response is DryRunOperation . Otherwise, it is
	// UnauthorizedOperation .
	DryRun *bool

	// The maximum number of items to return for this request. To get the next page of
	// items, make another request with the token returned in the output. For more
	// information, see [Pagination].
	//
	// [Pagination]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Query-Requests.html#api-pagination
	MaxResults *int32

	// The token to use to retrieve the next page of results.
	NextToken *string

	noSmithyDocumentSerde
}

type DescribeCapacityBlockExtensionOfferingsOutput struct {

	// The recommended Capacity Block extension offerings for the dates specified.
	CapacityBlockExtensionOfferings []types.CapacityBlockExtensionOffering

	// The token to use to retrieve the next page of results. This value is null when
	// there are no more results to return.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationDescribeCapacityBlockExtensionOfferingsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsEc2query_serializeOpDescribeCapacityBlockExtensionOfferings{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsEc2query_deserializeOpDescribeCapacityBlockExtensionOfferings{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "DescribeCapacityBlockExtensionOfferings"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addSpanRetryLoop(stack, options); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addCredentialSource(stack, options); err != nil {
		return err
	}
	if err = addOpDescribeCapacityBlockExtensionOfferingsValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opDescribeCapacityBlockExtensionOfferings(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	if err = addSpanInitializeStart(stack); err != nil {
		return err
	}
	if err = addSpanInitializeEnd(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestStart(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestEnd(stack); err != nil {
		return err
	}
	return nil
}

// DescribeCapacityBlockExtensionOfferingsPaginatorOptions is the paginator
// options for DescribeCapacityBlockExtensionOfferings
type DescribeCapacityBlockExtensionOfferingsPaginatorOptions struct {
	// The maximum number of items to return for this request. To get the next page of
	// items, make another request with the token returned in the output. For more
	// information, see [Pagination].
	//
	// [Pagination]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Query-Requests.html#api-pagination
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// DescribeCapacityBlockExtensionOfferingsPaginator is a paginator for
// DescribeCapacityBlockExtensionOfferings
type DescribeCapacityBlockExtensionOfferingsPaginator struct {
	options   DescribeCapacityBlockExtensionOfferingsPaginatorOptions
	client    DescribeCapacityBlockExtensionOfferingsAPIClient
	params    *DescribeCapacityBlockExtensionOfferingsInput
	nextToken *string
	firstPage bool
}

// NewDescribeCapacityBlockExtensionOfferingsPaginator returns a new
// DescribeCapacityBlockExtensionOfferingsPaginator
func NewDescribeCapacityBlockExtensionOfferingsPaginator(client DescribeCapacityBlockExtensionOfferingsAPIClient, params *DescribeCapacityBlockExtensionOfferingsInput, optFns ...func(*DescribeCapacityBlockExtensionOfferingsPaginatorOptions)) *DescribeCapacityBlockExtensionOfferingsPaginator {
	if params == nil {
		params = &DescribeCapacityBlockExtensionOfferingsInput{}
	}

	options := DescribeCapacityBlockExtensionOfferingsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &DescribeCapacityBlockExtensionOfferingsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *DescribeCapacityBlockExtensionOfferingsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next DescribeCapacityBlockExtensionOfferings page.
func (p *DescribeCapacityBlockExtensionOfferingsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*DescribeCapacityBlockExtensionOfferingsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	optFns = append([]func(*Options){
		addIsPaginatorUserAgent,
	}, optFns...)
	result, err := p.client.DescribeCapacityBlockExtensionOfferings(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

// DescribeCapacityBlockExtensionOfferingsAPIClient is a client that implements
// the DescribeCapacityBlockExtensionOfferings operation.
type DescribeCapacityBlockExtensionOfferingsAPIClient interface {
	DescribeCapacityBlockExtensionOfferings(context.Context, *DescribeCapacityBlockExtensionOfferingsInput, ...func(*Options)) (*DescribeCapacityBlockExtensionOfferingsOutput, error)
}

var _ DescribeCapacityBlockExtensionOfferingsAPIClient = (*Client)(nil)

func newServiceMetadataMiddleware_opDescribeCapacityBlockExtensionOfferings(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "DescribeCapacityBlockExtensionOfferings",
	}
}
